\section{Problem: Optimal Control}
\label{sec:problem}

A dynamic object is described by \autoref{eqn:dynamic-object}. One can deduce
that $x_1$ represents the position of this dynamic object while $x_2$
corresponds to its velocity.

\begin{equation}
    \begin{split}
    \dot{x_1}(t) &=  x_2(t)\\
    \dot{x_2}(t) &=  u(t) - x_2(t)
    \end{split}
    \label{eqn:dynamic-object}
\end{equation}

With the initial conditions represented in \autoref{eqn:initial-conditions}:

\begin{equation}
    \begin{split}
    x_1(0) &=  0\\
    x_2(0) &=  -1
    \end{split}
    \label{eqn:initial-conditions}
\end{equation}

Find the control $u(t),\quad 0 \leq t \leq 1$, minimizing \autoref{eqn:cost-function}:

\begin{equation}
    J(x, u) = \int_{0}^{1}  \left[x_1^2(t)+x_2^2(t)+0.005\cdot u^2(t)\right] \,dt 
    \label{eqn:cost-function}
\end{equation}

With the state constraint defined in \autoref{eqn:state-constraint}:

\begin{equation}
    x_2(t)\leq 8(t-0.5)^2-0.5,\quad 0\leq t\leq 1
    \label{eqn:state-constraint}
\end{equation}

Use piecewise constant (stair) representation of functions $u(t)$ and $x_1(t)$,
$x_2(t)$, dividing time horizon into $N = 50$ subintervals.